;
; ==========================================================================
;
;	PA Demo
;
; ==========================================================================
;
demo_main				;main entry point
	ld	hl,pa_pname		;set program name
	sys_call	dc_nam
	ld	hl,demo_init
	sys_call	gn_sop
;
	include	'demo 000.asm'
	include	'demo timechart.asm'
;
	ret			;return
;
; ==========================================================================
;
;	Support routines
;
; ==========================================================================
;
;
;	Box drawing routine, draws a box out on the screen, and then
;	defines a window within that box, and sets output to that
;	window.
;
;	Window 6 is used as the window name
;
;	Passed parameters are as follows:
;
;	BC - Origin for the box (x,y)
;	HL - Size of the box (length,height)
;
draw_box
	push	bc		;save location
	push	hl		;save size
	aprint	1		;define overall window
	aprint	"'7'"	
	aprint	"'#'"
	aprint	"'6'"
	ld	a,b
	add	a,32
	sys_call	os_out
	ld	a,c
	add	a,32
	sys_call	os_out
	ld	a,h
	add	a,32
	sys_call	os_out
	ld	a,l
	add	a,32
	sys_call	os_out
	aprint	128
	aprint	1		;initialize window
	aprint	"'2'"
	aprint	"'C'"
	aprint	"'6'"
	line_char_mac	67	;left corner
	pop	bc		;get size in bc
	push	bc
	dec	b		;adjust length
	dec	b
draw_box_1
	line_char_mac	69	;horizontal bar
	djnz	draw_box_1
	line_char_mac	70	;right corner
	pop	hl		;get size back
	push	hl
	ld	b,l		;get size
	dec	b		;downscale (cursor is at 0,1)
	dec	b
draw_box_2
	aprint	10		;lf to end of window
	djnz	draw_box_2

	line_char_mac	73	;left corner
	pop	hl		;get size back
	push	hl
	ld	b,h		;get width
	dec	b		;adjust width
	dec	b
draw_box_3
	line_char_mac	69	;horizontal bar
	djnz	draw_box_3
	line_char_mac	76	;right corner
;
;	Now have a window with top and bottom bars, define the sub-window
;
	pop	hl		;get size and location
	pop	bc		;back
	inc	b		;and adjust them
	inc	c
	dec	h
	dec	h
	dec	l
	dec	l
;
	aprint	1		;define overall window
	aprint	"'7'"	
	aprint	"'#'"
	aprint	"'6'"
	ld	a,b
	add	a,32
	sys_call	os_out
	ld	a,c
	add	a,32
	sys_call	os_out
	ld	a,h
	add	a,32
	sys_call	os_out
	ld	a,l
	add	a,32
	sys_call	os_out
	aprint	129		;turn sidebars on
	aprint	1		;initialize window
	aprint	"'2'"
	aprint	"'C'"
	aprint	"'6'"
	ret			;and return
;
gotoxy
	ld	a,1	;set up prefix
	sys_call	os_out
	ld	a,'3'
	sys_call	os_out
	ld	a,'@'
	sys_call	os_out
	ld	a,b	;set position
	add	a,32
	sys_call	os_out
	ld	a,c
	add	a,32
	sys_call	os_out
	ret
;
demo_outcal
	ld	hl,demo_outcal_msg
	sys_call	gn_sop
	ret
demo_outcal_move
	ld	hl,demo_outcal_msg1
	sys_call	gn_sop
	ret
demo_outcal_msg
	vid_win_sel	1
	vid_win_grey
	vid_win_sel	2
	vid_win_grey
	vid_win_sel	3
	vid_win_grey
	vid_win_titled1	5,9,0,35,8,"NOVEMBER 1990"
	vid_tiny_toggle
	vid_underline_toggle
	db	' MON  TUE  WED  THU  FRI  SAT  SUN '
	vid_tiny_toggle
	vid_underline_toggle	
	db	'                  1    2    3    4 '
	db	'   5    6    7    8    9   10   11 '
	db	'  12   13   14 '
	vid_reverse_toggle
	db	'  15 '
	vid_reverse_toggle
	db	'  16   17   18 '
	db	'  19   20   21   22   23   24   25 '
	db	'  26   27   28   29   30'
	db	0
demo_outcal_msg1
	vid_win_sel	5
	vid_gotoxy	15,3
	db	'  15 '
	vid_gotoxy	5,4
	vid_reverse_toggle
	db	'  20 '
	vid_reverse_toggle
	db	0
;
init_win_1
	ld	hl,win_def_1
	sys_call	gn_sop
	ret
init_win_2
	ld	hl,win_def_2
	sys_call	gn_sop
	ret
init_win_3
	ld	hl,win_def_3
	sys_call	gn_sop
	ret
;
; ==========================================================================
;
;	Static storage area
;
; ==========================================================================
;
pa_pname	db	'PA Demo',0
;
demo_init
	db	1,138,'=','A',191,191,191,191,191,191,191,191
	db	0
;
dwsel1	vid_win_sel	1
	vid_win_nogrey	1
	db	0
dwsel2	vid_win_sel	2
	vid_win_nogrey	2
	db	0
dwsel3	vid_win_sel	3
	vid_win_nogrey	3
	db	0
dwsel4	vid_win_sel	4
	vid_win_nogrey	4
	db	0
dwsel5	vid_win_sel	5
	vid_win_nogrey	5
	db	0
;
win_def_1
	vid_win	1,1,0,44,8,1
	vid_win_sel_ic	1
	db	0
win_def_2
	vid_win	2,46,0,44,8,1
	vid_win_sel_ic	2
	db	0
win_def_3
	vid_win	3,0,0,92,8,0
	vid_win_sel_ic	3
	db	0
;
; ==========================================================================
;
;	Dynamic storage area
;
; ==========================================================================
;
