	title	Hex Import
;
; ==========================================================================
;
;	This module is the DOR Dump program
;
; ==========================================================================
;
dor_dump
	ld	hl,dd_mainwin	;set up main window
	sys_call	gn_sop
	jr	:+1
	ld	b,040h		;get name
	ld	a,0
	ld	c,0
	ld	de,dd_fname
	sys_call	gn_sip
:
	ld	a,12		;clear screen
	sys_call	os_out
	ld	a,06h
	ld	b,0		;open dor
	ld	c,040h
	ld	hl,dd_fname
	ld	de,dd_scratch
	sys_call	gn_opf
	jp	c,dd_error
	ld	(dd_handle),ix	;save DOR handle
	ld	hl,dd_scratch	;print filename
	sys_call	gn_sop
	call	pause
	call	dd_dumpdor
	call	pause
;
dd_done
	call	dd_cleanup
	ret
;
dd_cleanup				;cleanup routine
	ld	hl,(dd_handle)	;close dor if need be
	ld	a,h
	or	l
	jr	z,:+1		;not in use
	push	hl		;get handle
	pop	ix
	ld	a,dr_fre		;free handle
	sys_call	os_dor
:
	call	reset_win
	ret
;
dd_error				;error branch
	call	dd_cleanup
	jp	exit		;basic exit poinit
;
; ==========================================================================
;
;	Support routines
;
; ==========================================================================
;
dd_dumpdor				;dump dor
	ld	ix,(dd_handle)	;read DOR
	ld	de,dd_dorptr	;set buffer
	ld	c,00bh		;buffer length
	ld	b,'H'		;help record
	ld	a,dr_rd		;read
	sys_call	os_dor
	jp	c,dd_error
	ld	a,(dd_dorptr+2)	;get topic bank
	ld	b,a		;and map it into segment 3
	ld	c,03h		;set segment
	sys_call	os_mpb		;remap
	push	bc		;save bindings
	ld	hl,(dd_dorptr)	;get offset
	ld	a,h		;get high part of address
	and	03fh		;and map to bank three
	or	0c0h
	ld	h,a
:
	ld	a,(hl)		;check for zero
	and	a
	jr	nz,dd_dump_error
	inc	hl
:
	ld	a,(hl)		;get length
	and	a		;check for zero
	jr	z,dd_dumpeot
	push	af		;save length
	push	hl		;and address
:
	inc	hl		;next value
	ld	a,(hl)		;get byte
	cp	020h		;check for control
	jr	c,:+1		;and done if so
	sys_call	os_out		;output byte
	jr	:-1		;and loop
:
	ld	hl,dd_crlf		;output cr/lf
	sys_call	gn_sop
	pop	hl		;get address back and update
	pop	af
	ld	e,a
	ld	d,0
	add	hl,de
	jr	:-3		;next topic
;
dd_dumpeot				;end of topics
;
dd_dumpdone				;done dumping
	pop	bc		;get bindings and reset
	sys_call	os_mpb
	ret
;
dd_dump_error			;error reading information
	pop	bc		;get bindings
	sys_call	os_mpb		;and remap
	jp	dd_error		;error exit
;
; ==========================================================================
;
;	Static data area
;
; ==========================================================================
;
dd_mainwin				;main window
	vid_win_1	1,0,0,80,8
	db	'DOR DUMP v1.00'
	vid_win_2	1,0,0,80,8
	db	12,10,10
	db	'File (Application) : '
	db	0
dd_crlf				;cr/lf
	db	13,10,0
;
; ==========================================================================
;
;	Dynamic data area
;
; ==========================================================================
;
dd_bank	db	0		;bank number
dd_handle	dw	0		;dor handle
dd_dorptr	bsz	12		;table offsets
dd_fname	db	':rom.0/appl/pipedream',0
	bsz	040h		;file name
dd_scratch	bsz	040h		;scratch