;
; ==========================================================================
;
;	HELP ROM.asm
;
;	This file contains the ROM DOR and related table information
;	for the dummy HELP application
;
; ==========================================================================
;
	set_epseg_1			;set to top segment
help_dor
	db	0,0,0		;link to parent
	dw	zm_dor&3fffh	;pointer to Graph DOR
	db	03fh
	db	0,0,0		;link to son
	db	083h		;dor type
	db	:+8-:+1		;dor length
:
	db	'@'		;key to info section
	db	:+2-:+1		;length of info section
:
	dw	0		;reserved
	db	'H'		;access key
	db	0		;contiguous ram required
	dw	0		;environment overhead
	dw	0		;unsafe space needed
	dw	0008h		;save space needed
	dw	help_apl_entry	;entry point
	db	0		;binding on entry; segment 1
	db	0		;binding on entry; segment 2
	db	0		;binding on entry; segment 3
	db	03eh		;binding on entry; segment 4
	db	09h		;application type byte 1 (Popdown)
	db	00h		;application type byte 2
:
	db	'H'		;key to help section
	db	:+2-:+1		;length of help section
:
	dw	help_topic&3fffh	;pointer to topics
	db	03fh
	dw	help_cmds&3fffh	;pointer to commands
	db	03fh
	dw	help_help&3fffh	;pointer to appl. help
	db	03fh
	dw	help_tok&3fffh	;pointer to token base
	db	03fh
:
	db	'N'		;key to name section
	db	:+2-:+1		;length of name section
:
	db	'Z-Help',0
:
	db	0ffh		;dor terminator
:
	include	'::HelpGen:help.asm'	;help data
;
	set_epseg_2			;set to code segment
help_apl_entry
	call	help_entry		;call entry point
	scf			;enquiry entry point
	ret
;
help_entry
	sys_call	os_in		;get an input value
elp_exit
	xor	a		;no error exit
	sys_call	os_bye
;
