;
; ==========================================================================
;
;	Test Application.asm
;
;	This file contains a short test application for ROM
;
; ==========================================================================
;
	set_epseg_1			;set to top segment
	db	0,0,0		;link to parent
	db	0,0,0		;link to brother
	db	0,0,0		;link to son
	db	083h		;dor type
	db	:+8-:+1		;dor length
:
	db	'@'		;key to info section
	db	:+2-:+1		;length of info section
:
	dw	0		;reserved
	db	'U'		;access key
	db	0		;contiguous ram required
	dw	0		;environment overhead
	dw	0		;unsafe space needed
	dw	0100h		;save space needed
	dw	0c000h		;entry point
	db	0		;binding on entry; segment 1
	db	0		;binding on entry; segment 2
	db	0		;binding on entry; segment 3
	db	03eh		;binding on entry; segment 4
	db	01h		;application type byte 1
	db	00h		;application type byte 2
:
	db	'H'		;key to help section
	db	:+2-:+1		;length of help section
:
	null_topic			;pointer to topics
	null_topic			;pointer to commands
	null_topic			;pointer to appl. help
	null_topic			;pointer to token base
:
	db	'N'		;key to name section
	db	:+2-:+1		;length of name section
:
	db	'Test App.',0
:
	db	0ffh		;dor terminator
:
;
	set_epseg_2			;set to code segment
	call	testap_entry	;call entry point
	scf			;enquiry entry point
	ret
;
testap_entry
	xor	a		;zero a
	ld	b,a		;and b
	ld	hl,testap_errhan	;set up error handler
	sys_call	os_erh
	ld	a,5		;enable escape detection
	sys_call	os_esc
	call	testap_main
;
testap_exit
	xor	a		;no error exit
	sys_call	os_bye
;
testap_errhan			;error handler
	ret	z		;return if fatal
	cp	rc_esc		;check for esc
	jr	nz,:+1
	sys_call	os_esc		;acknowledge esc
	cp	a		;set flags
	ret			;and return
:
	cp	rc_quit		;check for quit request
	jr	nz,:+1
	xor	a
	sys_call	os_bye		;exit appl
:
	cp	a		;set flags
	ret			;and return
;
testap_main				;main start for testap
	ld	hl,msg1		;just put out a message
	sys_call	gn_sop
	sys_call	os_in		;wait for a key
	ret
;
msg1
	vid_win_1	1,10,0,50,8
	db	'Test Window'
	vid_win_2	1,10,0,50,8
	db	10,10
	vid_just_center
	db	'This is a test application',13
	db	0