;
; ----------------------------------------------------------------------
;
;	Xmodem transfer protocal module
;
; ----------------------------------------------------------------------
;
;	Also supports transfer of files using MACbinary protocal
;
; ----------------------------------------------------------------------
;
xmd_timeout	equ	0200H		;timeout in centiseconds
;
xmodem_entry
	ret
;
; ----------------------------------------------------------------------
;
;	Support routines
;
; ----------------------------------------------------------------------
;
;	xmd_open_com	open com port
;	xmd_put_byte	put A out com port
;	xmd_get_byte	get A from com port
;	xmd_rcv_block	get a full xmodem block
;
xmd_open_com
	ld	a,1		;set for input
	ld	hl,xmd_com_filename	;com file name
	ld	de,xmd_buffer	;scratch buffer
	ld	c,xmd_buffer_len	;scratch buffer length
	gn_opf			;open the file
	jp	c,file_error	;jump to error exit or error
	ld	(xmd_com_handle),ix	;save access handle
	ret
xmd_com_filename
	db	':COM',0		;COM port file name
;
xmd_put_byte
	ld	ix,(xmd_com_handle)	;get com port handle
	ld	bc,xmd_timeout	;set timeout
	os_pbt			;do it
	ret
;
xmd_get_byte
	ld	ix,(xmd_com_handle)	;get com port handle
	ld	bc,xmd_timeout	;set timeout
	os_gbt			;do it
	ret
;
xmd_rcv_block
	ld	hl,xmd_buffer	;get buffer address
	ld	hl,0		;zero block counter
	ld	(xmd_block_counter),hl
	xor	a		;zero segment number
	ld	(xmd_seg_number),a
	ld	a,NAK		;send out a NAK
	call	xmd_put_byte
	
	call	xmd_get_byte	;get a byte
	



