	title	ROM Dump Program
;
; ----------------------------------------------------------------------
;
;	ROM Utility Program
;
;	Program to support operations on ROM chips, the following
;	functions are supported:
;
;	Blank verify - verify that the EPROM is blank
;	Dump - Make INTEL HEX dump of the EPROM
;
; ----------------------------------------------------------------------
;

	lib	'::syslib:sysmac'
	basic_header	r.bas
;
	z88_name	'EPROM Util v1.0'
main:
	call	main_draw
main_in:
	os_in		;get a key
	jp	c,all_done	;if error exit program
	call	a_to_lower	;make lower case
	cp	'e'	;exit
	jp	z,all_done
	cp	's'	;status EPROM
	jp	nz,main_ns
	call	sel_eprom	;prompt for desired eprom
	jp	main
main_ns:
	cp	'v'	;verify EPROM
	jp	nz,main_nv
	call	ins_eprom	;prompt to insert EPROM in slot 3
	jp	main
main_nv:
	cp	'd'	;dump this EPROM
	jp	nz,main_nd
	call	sel_eprom	;prompt for desired EPROM
	jp	main
main_nd:
	jp	main_in
;
;	End of main program
;
all_done:
	call	clean_bas_win	;reset window
;
	ret
;
;	Prompt for user to insert EPROM in slot three
;
ins_eprom:
	ld	hl,ins_eprom_m1
	gn_sop
	os_in		;get a character
	ret
;
;	Prompt for EPROM to use
;
sel_eprom:
	ld	hl,sel_eprom_m1
	gn_sop
sel_eprom_1:
	os_in		;get a character
	cp	'1'	;check range
	jr	c,sel_eprom_1
	cp	'4'
	ret	c
	jr	sel_eprom_1
;
;	Redraw main window
;
main_draw:
	ld	hl,c_msg
	call	cpyright_win
main_rdrw:
	ld	hl,main_win	;put out main window
	gn_sop
	ret
;
;	Exit cleanup
;
exit_cleanup:
	ret
;
;	Static Data Storage
;
c_msg:
	db	'EPROM Util v1.0',0
main_win:
	vid_win_titled	1,0,0,68,8,'MAIN MENU'
main_wina
	vid_just_center
	vid_cursor_toggle
	db	10,10
	vid_bold_toggle
	db	'D'
	vid_bold_toggle
	db	')ump   '
	vid_bold_toggle
	db	'E'
	vid_bold_toggle
	db	')xit   '
	vid_bold_toggle
	db	'S'
	vid_bold_toggle
	db	')tatus   '
	vid_bold_toggle
	db	'V'
	vid_bold_toggle
	db	')erify Erase'
	db	13,0
;
ins_eprom_m1:
	vid_win_titled	1,0,0,68,8,'INSERT EPROM'
	vid_just_center
	vid_cursor_toggle
	db	10,10
	db	'Place desired EPROM in slot 3'
	db	13,10,10
	db	'Press <ENTER> to continue'
	db	13,0
sel_eprom_m1:
	vid_win_titled	1,0,0,68,8,'EPROM SELECT'
	vid_just_center
	vid_cursor_toggle
	db	10,10
	db	'Which slot is the EPROM in?'
	db	13,10,10
	db	'(1)   (2)   (3)'
	db	13,0
;
;	Dynamic Data Storage
;
;
	lib	'::syslib:genlib.asm'
;	lib	'::syslib:crc.asm'
;
	end