	title	Screen
;
; ----------------------------------------------------------------------
;
;	Screen program - test bed for screen routines
;
; ----------------------------------------------------------------------
;
main:
	call	get_screen_address
	ret
	ld	hl,msg
	sys_call	gn_sop
	ld	a,5
	ld	bc,0000h
	ld	de,buf
	call	get_screen_data
	xor	a
	ld	(de),a
	ld	hl,buf
;	sys_call	gn_sop
;	sys_call	gn_nln
	ret
;
msg	db	12,10,10
	db	'This is message number one',13,10
	db	'This is a test message on the screen here',13,10
	db	'and here is some more stuff'
	db	13,10,0
;
buf	bsz	512

;
; ==========================================================================
;
;	Screen access support routines
;
;	These routine support direct access to the screen area on
;	the Z88.
;
; ==========================================================================
;
;	get_screen_address - returns the screen address in BHL
;
;	get_screen_data - returns a text string from a screen location
;		A - Length of data to return, can not exceed right
;			edge of window.
;		B - Column
;		C - Row
;		DE - Buffer to store data at
;
; ==========================================================================
;
get_screen_data			;get screen information
	push	af		;save count
	push	bc		;location
	push	de		;and buffer location
	call	get_screen_address	;get screen address
	push	hl		;save offset
	ld	c,02h		;map to top bank
	sys_call	os_mpb		;remap
	exx			;save mapping in alt
	pop	hl		;get offset back
	ld	a,h		;set upper bits of address
	or	080h
	ld	h,a
	pop	bc		;get buffer address
	pop	de		;and cursor location
	ld	a,e		;double row
	add	a,e
	ld	e,a		;and save
	ld	a,d		;then add in carry
	adc	a,00h
	ld	d,a
	add	hl,de		;then adjust address
	ld	d,b		;and move bc into de
	ld	e,c
	pop	bc		;and get counter in c
get_screen_data_1
	ld	a,(hl)		;move from (HL) to (DE)
	ld	(de),a
	inc	de		;count de
	inc	hl		;double count hl
	inc	hl
	djnz	get_screen_data_1	;loop till done
	push	de		;save address
	exx			;get alt set back
	sys_call	os_mpb		;and remap bank
	pop	de		;restore pointer
	ret			;and return
;
get_screen_address			;get screen address
	ld	a,05h		;set for address return
	ld	hl,3800h		;default mapping
	ld	b,21h
	sys_call	os_sci		;remap
;	push	bc		;save old mapping
;	push	hl
	sys_call	os_sci		;and map back
;	pop	hl		;get back
;	pop	bc
	ret			;and return
;
