	title	Debuger
;
; ==========================================================================
;
;	This file is a callable debug routine
;
; ==========================================================================
;
debug
	push	af		;save all register
	push	bc
	push	de
	push	hl
	push	ix
	push	iy
	ex	af,af'		;including alternates
	exx
	push	af
	push	bc
	push	de
	push	hl
;
;	Everything is now saved, output the window
;
	ld	hl,debug_win	;draw out window
	sys_call	gn_sop
;
;	Now set up the address where things started on the stack,
;	and get everything from there. The pointer is set to one past
;	where we want, then the display routine is called in the middle,
;	using the actual value of HL, subsequent calls print out (HL), the
;	value of HL (the pointer to the data on the stack) being
;	incremented with the full calls.
;
	ld	hl,0		;find current stack
	add	hl,sp
	ld	de,0016h		;add 11 pairs
	add	hl,de		;make pointer
	ld	bc,04a00h		;set screen pos
	call	debug_regdis1	;on the first call)
	ld	bc,3c00h		;set screen pos
	call	debug_regdis	;PC
	ld	bc,0400h		;set screen pos
	call	debug_regdis	;af
	ld	bc,1200h		;set screen pos
	call	debug_regdis	;bc
	ld	bc,2000h		;set screen pos
	call	debug_regdis	;de
	ld	bc,2e00h		;set screen pos
	call	debug_regdis	;hl
	ld	bc,3c01h		;set screen pos
	call	debug_regdis	;ix
	ld	bc,4a01h		;set screen pos
	call	debug_regdis	;iy
	ld	bc,0401h		;set screen pos
	call	debug_regdis	;af'
	ld	bc,1201h		;set screen pos
	call	debug_regdis	;bc'
	ld	bc,2001h		;set screen pos
	call	debug_regdis	;de'
	ld	bc,2e01h		;set screen pos
	call	debug_regdis	;hl'
;
	call	debug_memdis	;display memory block
;
debug_main
	call	debug_erasecmd	;erase command line
	ld	hl,debug_cmdmsg	;put out command message
	sys_call	gn_sop
:
	sys_call	os_in		;get command
	jr	c,:-1		;loop if preempt
;
	cp	00h		;check for arrow keys
	jr	nz,:+2
:
	sys_call	os_in		;get next key
	jr	c,:-1
	cp	0ffh		;up arrow
	jp	z,debug_memdisdn
	cp	0feh		;down arrow
	jp	z,debug_memdisup
	jr	:-2
:
	call	a_to_lower		;conver to lower case
	cp	'm'		;change memory display
	jp	z,debug_getmem
	cp	'q'		;basic exit routine
	jp	z,exit_all
	cp	'r'		;return to caller
	jp	debug_done
	jp	:-3
;
debug_regdis1			;alt entry into debug_regdis
	push	hl		;save hl
	jr	debug_regdis2
debug_regdis			;display register
	dec	hl
	ld	d,(hl)		;get high byte
	dec	hl
	ld	e,(hl)		;get low byte
	push	hl		;save HL
	ex	de,hl		;and put value in HL
debug_regdis2
	push	hl		;save value
	call	gotoxy		;set cursor
	call	hl_to_hexdis	;display it
	pop	hl		;get value back
	ld	a,20h		;put out a space
	sys_call	os_out
	ld	a,h		;put out ASCII
	call	a_print_out
	ld	a,l
	call	a_print_out
	pop	hl		;get address back
	ret			;return
;
debug_getmem			;get new memory address
	call	debug_erasecmd	;erase command line
	ld	hl,debug_gmmsg	;output prompt
	sys_call	gn_sop
	ld	de,debug_buffer	;set buffer address
	ld	a,0		;set mode
	ld	b,5
	sys_call	gn_sip		;get input line
	ld	hl,debug_buffer	;get characters and convert
	ld	b,(hl)		;to hex
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	e,(hl)
	inc	hl
	call	hex_to_hl		;convert it
	ld	(debug_disloc),hl	;save it
	call	debug_memdis	;and update display
	jp	debug_main
;
debug_memdisup			;up a block of memory
	ld	de,0020h		;set up count
	jr	debug_memdisscroll
debug_memdisdn			;down a block of memory
	ld	de,0ffe0h		;set up count (rollover)
	jr	debug_memdisscroll
debug_memdisscroll			;up address by DE and display
	ld	hl,(debug_disloc)	;get address
	add	hl,de		;increment
	ld	(debug_disloc),hl	;save updated address
	call	debug_memdis	;update display
	jp	debug_main		;and back to main menu
;
debug_memdis			;display memory block
	ld	bc,0a02h		;set initial cursor position
	ld	de,0010h		;set increment
	ld	hl,(debug_disloc)	;set buffer address
	ld	a,4		;set count
:
	pushall			;save registers
	call	gotoxy		;set cursor
	call	debug_memdis1	;display this line
	popall			;get the regs back
	add	hl,de		;increment offset
	inc	c		;next row
	dec	a		;count this
	jr	nz,:-1		;loop till done
	ret			;return
;
debug_memdis1
	push	hl		;save a few copies of hl
	push	hl
	ld	a,h		;convert to hex and display
	call	a_to_hexdis
	pop	hl
	ld	a,l
	call	a_to_hexdis
	ld	a,':'		;put out trailing colon
	sys_call	os_out
	ld	a,20h		;and a space
	sys_call	os_out
	ld	de,0		;prefix
	pop	hl		;and get address
	call	display_hex_line
	ret			;return
;
debug_erasecmd			;erase the command line
	ld	bc,0106h		;set cursor
	call	gotoxy
	ld	b,80		;set cursor count
	ld	a,' '		;set for space
:
	sys_call	os_out		;print the space
	dec	b
	jr	nz,:-1
	ld	bc,0106h		;set cursor
	call	gotoxy
	ret			;return
;
debug_done				;exit point, get all reg back
	pop	hl		;get alternate registers
	pop	de
	pop	bc
	pop	af
	exx
	ex	af,af'
	pop	iy		;get main registers
	pop	ix
	pop	hl
	pop	de
	pop	bc
	pop	af
	ret			;return to caller
;
; ==========================================================================
;
;	Static Data Area
;
; ==========================================================================
;
debug_win			;main window
	vid_win_1	4,0,0,88,8
	db	'DEBUG WINDOW'
	vid_win_2	4,0,0,88,8
	vid_gotoxy	1,0
	db	'AF'
	vid_gotoxy	15,0
	db	'BC'
	vid_gotoxy	29,0
	db	'DE'
	vid_gotoxy	43,0
	db	'HL'
	vid_gotoxy	57,0
	db	'PC'
	vid_gotoxy	71,0
	db	'SP'
	vid_gotoxy	1,1
	db	'af'
	vid_gotoxy	15,1
	db	'bc'
	vid_gotoxy	29,1
	db	'de'
	vid_gotoxy	43,1
	db	'hl'
	vid_gotoxy	57,1
	db	'IX'
	vid_gotoxy	71,1
	db	'IY'
	vid_gotoxy	1,2
	db	'Memory'
	db	0
debug_cmdmsg			;command line prompt
	db	'Command: '
	vid_bold_toggle
	db	'M)'
	vid_bold_toggle
	db	'emory, '
	vid_bold_toggle
	db	'Q)'
	vid_bold_toggle
	db	'uit, '
	vid_bold_toggle
	db	'R)'
	vid_bold_toggle
	db	'eturn'
	db	0
debug_gmmsg				;get memory address message
	db	'Memory address to display (xxxx) : '
	db	0
;
; ==========================================================================
;
;	Dynamic Data Area
;
; ==========================================================================
;
debug_disloc			;memory display location
	dw	2300h
debug_buffer			;scratch buffer
	bsz	10h