;
; ==========================================================================
;
;	Menu draw routine
;
;	This routine creates a window on the screen with a number
;	of choices displayed as strings, and allows the user to 
;	select one of the choices by highlighting the specified
;	selection.
;
;	Input:
;		BC - column/row of upper left hand corner of menu
;		HL - Pointer to definition block for the menu
;
;	Output:
;		A - Choice made, 0 referenced
;
;	The menu is defined by the block pointed to by HL on entry,
;	which has the following format:
;
;	(HL)	Pointer to title string (NULL terminated)
;	(HL+2)	Pointer to first menu item
;	(HL+2n)	Pointer to nth item
;	(HL+2n+2)	0000h - end of table marker
;
; ==========================================================================
;
menu
	push	bc		;save cursor location
	push	hl		;save table location
menu_done
	ret			;and return
