	title	ZClip
;
; ==========================================================================
;
;	This module is the Z88 clipboard program.
;
; ==========================================================================
;
;	This program performs cut/paste operations on the Z88 as follows:
;
;	<>C - Copy information to the clipboard, the current screen is
;		saved in a buffer, and the cursor used to mark a block
;		of text, which is then written to a scratch file.
;
;	<>V - Paste information to the clipboard, the previously copied
;		information from the scratch file is pasted back in
;		through a .CLI file.
;
; ==========================================================================
;
zclp_entry
	ld	hl,0		;save the stack state
	add	hl,sp
	ld	(zclp_stack),hl
	ld	hl,0		;zero out handles
	ld	(zclp_handle),hl
	ret
;
zclp_done
	ld	hl,zclp_handle	;check file and close if need be
	call	close_file
	ret			;return
;
; ==========================================================================
;
;	Support routines
;
; ==========================================================================
;
