/********************************************************************

	Include file for the ZBase to micro asm compiler

********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/********************************************************************

	Structure definitions

********************************************************************/


	struct varstruct {
		struct varstruct *next;		/* pointer to next variable */
		char name[11];				/* variable name */
		int length;					/* index number */
		};

/********************************************************************

	Command equivalences

********************************************************************/

#define NUM_COMMANDS 23

#define ZPRINT	0
#define ZAT	1
#define ZDELETE	2
#define ZDO	3
#define ZELSE	4
#define ZENDDO	5
#define ZENDIF	6
#define ZFIND	7
#define ZGO	8
#define ZIF	9
#define ZLET	10
#define ZSELECT	11
#define ZUSE	12
#define ZRESTORE	13
#define ZSAY	14
#define ZGET	15
#define ZRECORD	16
#define ZWHILE	17
#define ZRETURN	18
#define ZDECLARE	19
#define ZSTRING	20
#define ZNUMERIC	21
#define ZCLS	22

/********************************************************************

	Function equivalences

********************************************************************/

#define NUM_FUNC 5

#define ZASC	0
#define ZCHR	1
#define ZDATE	2
#define ZTIME	3
#define ZRECNO	4


/********************************************************************

	Function prototypes

********************************************************************/

	void write_var_table(struct varstruct *var);

/*

	Include file to define all of the external globals used by ZDC.

*/

	 extern FILE *source_file, *asm_file;	/* file pointers */
	 extern char card[];			/* input buffer */
	 extern char *card_ptr;			/* pointer to current parameter */
	 extern struct varstruct *var;	/* first variable */
	 extern int labindex;			/* label counter */
	 extern int iflevel;			/* if nesting level */
	 extern int iflabel[];			/* if label branches */
	 extern int whilelevel;			/* while level */
	 extern int whilelabel[];		/* while label branches */
	 extern int gerr;				/* global error flag */
	 extern int com_flag;			/* comment flag, 0 for no comments */

	 extern char *command_names[];	/* command name table */
	 extern char *func_names[];		/* function names */
