;
; ==========================================================================
;
;	ZMacro ROM.asm
;
;	This file contains the ROM DOR and related table information
;	for the Macro application.
;
; ==========================================================================
;
	set_epseg_1			;set to top segment
zm_dor
	db	0,0,0		;link to parent
	dw	graph_dor&3fffh	;pointer to Graph DOR
	db	03fh
	db	0,0,0		;link to son
	db	083h		;dor type
	db	:+8-:+1		;dor length
:
	db	'@'		;key to info section
	db	:+2-:+1		;length of info section
:
	dw	0		;reserved
	db	'M'		;access key
	db	0		;contiguous ram required
	dw	0		;environment overhead
	dw	0		;unsafe space needed
	dw	0060h		;save space needed
	dw	zm_apl_entry	;entry point
	db	0		;binding on entry; segment 1
	db	0		;binding on entry; segment 2
	db	0		;binding on entry; segment 3
	db	03eh		;binding on entry; segment 4
	db	09h		;application type byte 1
	db	00h		;application type byte 2
:
	db	'H'		;key to help section
	db	:+2-:+1		;length of help section
:
	dw	zm_topics&3fffh	;pointer to topics
	db	03fh
	dw	zm_commands&3fffh	;pointer to commands
	db	03fh
	dw	zm_help&3fffh	;pointer to appl. help
	db	03fh
	dw	zm_tokens&3fffh	;pointer to token base
	db	03fh
:
	db	'N'		;key to name section
	db	:+2-:+1		;length of name section
:
	db	'Z-Macro',0
:
	db	0ffh		;dor terminator
:
;
	include	'::HelpGen:zmacro.asm'
;
	set_epseg_2			;set to code segment
zm_apl_entry
	call	zm_entry		;call entry point
	scf			;enquiry entry point
	ret
;
zm_entry
	xor	a		;zero a
	ld	b,a		;and b
	ld	hl,zm_errhan	;set up error handler
	sys_call	os_erh
	ld	a,5		;enable escape detection
	sys_call	os_esc
	call	zm_main
;
zm_exit
	xor	a		;no error exit
	sys_call	os_bye
;
zm_errhan				;error handler
	ret	z		;return if fatal
	cp	rc_esc		;check for esc
	jr	nz,:+1
	sys_call	os_esc		;acknowledge esc
	cp	a		;set flags
	ret			;and return
:
	cp	rc_quit		;check for quit request
	jr	nz,:+1
	xor	a
	sys_call	os_bye		;exit appl
:
	cp	rc_draw		;check for redraw
	jr	nz,:+1
;	call	zm_mainredraw	;redraw screen
	cp	a		;set flags and return
	ret
:
	cp	a		;set flags
	ret			;and return
;
